#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include "array_helpers.h"
#include "sort.h"


static bool is_valid_position(unsigned int length, unsigned int i) {
    return(i < length);
}

void swap(int *a, unsigned int length, unsigned int i, unsigned int j) {
/*
    Swap the value at position 'i' with the value at position 'j' in the
    array 'a'. The array 'a' must have exactly 'length' elements,
    and 'i' and 'j' must be valid positions in the array.

*/
    int original_i = 0, original_j = 0;

    /* Check preconditions */
    assert(a != NULL);
    assert(length >= 1);  /* at least one item in the array */
    assert(is_valid_position(length, i));
    assert(is_valid_position(length, j));

    original_i = a[i];
    original_j = a[j];

    /* Needs implementation */

    /* Check postconditions */
    assert(original_i == a[j]);
    assert(original_j == a[i]);
    /* and the rest of the elements have not changed */
}

int min_pos_from(int *a, unsigned int length, unsigned int i) {
/*
    Return the position of the minimum value in the array 'a' starting
    at position 'i'. The array 'a' must have exactly 'length' elements,
    and 'i' must be a valid position in the array.

*/
    unsigned int result = 0;

    /* Check preconditions */
    assert(a != NULL);
    assert(is_valid_position(length, i));

    /* Needs implementation */

    /* Check postconditions */
    assert(is_valid_position(length, result));
    return(result);
}

void selection_sort(int *a, unsigned int length) {
    assert(a != NULL);

    /* Needs implementation */

    /* Check postconditions */
    assert(array_is_sorted(a, length));
}

void insertion_sort(int *a, unsigned int length) {
    assert(a != NULL);

    /* Needs implementation */

    /* Check postconditions */
    assert(array_is_sorted(a, length));
}

void quick_sort(int *a, unsigned int length) {
    assert(a != NULL);

    /* Needs implementation */

    /* Check postconditions */
    assert(array_is_sorted(a, length));
}
